#library "Player"
#include "zcommon.acs"

#define C_TID       1000    //Default camera tid
#define MAX_R       128     //Maximum radius (or distance from the player)
#define ADJUST_R    8       //Amount to adjust the camera by
#define VIEW_HEIGHT 41.0    //The approximate height of the player's view

bool cam_mode[8];           //Variable for turning the camera on or off.

// Code listing:
// 531: Enter script that monitors the Use button-pressing key.
// 532: Stops, freezes, and third-persons the player once sex is initiated.
// 533: Third-person camera so they can see the action going.

script 531 ENTER
{
    int buttons;

    GiveInventory("ReappearPlayer",1);

    while (1)
    {
    buttons = GetPlayerInput(-1, INPUT_BUTTONS);

    if (buttons & BT_USE)
        { GiveInventory("UseKey",1); /*Print(s:"Hitting Use.");*/ }
    else
        { TakeInventory("UseKey",0x7FFFFFFF); /*Print(s:"Not hitting Use.");*/ }
    delay(1);
    }
}

script 532 (int fuck)
{
    switch (fuck)
    {
    case 1:
        Thing_Stop(0);
        SetPlayerProperty(0,1,PROP_FROZEN);
        cam_mode[PlayerNumber ()] = ON;
        ACS_ExecuteAlways(533,0,PlayerNumber());
        break;

    case 2:
        SetPlayerProperty(0,0,PROP_FROZEN);
        cam_mode[PlayerNumber ()] = OFF;
        Thing_Remove (C_TID + PlayerNumber ());
        break;
    }
}

Script 533 (int p_num)
{
    int r = MAX_R;
    
    while (cam_mode[p_num] == ON)
    {    
        int a = GetActorAngle (0);
        int p = GetActorPitch (0);
        int x = GetActorX (0);
        int y = GetActorY (0);
        int z = GetActorZ (0) + VIEW_HEIGHT;
        int xyr = r * cos (p) >> 16;
        
        if (!ThingCountName ("ChaseCam", C_TID+p_num))
        {
            while (!Spawn ("ChaseCam", x-cos(a)*xyr, y-sin(a)*xyr, z+sin(p)*r, C_TID+p_num, a >> 8) && r > 0)
            {
                r -= ADJUST_R;
                xyr = cos (p) * r >> 16;
            }
            
            if (ThingCountName ("ChaseCam", C_TID + p_num))
                ChangeCamera (C_TID + p_num, 0, 0);
            else
            {
                cam_mode[p_num] = OFF;
                print (s:"Camera script failed to initialize.");
            }
        }
        else
        {
            while (!SetActorPosition (C_TID+p_num, x-cos(a)*xyr, y-sin(a)*xyr, z+sin(p)*r, 0) && r > 0)
            {
                r -= ADJUST_R;
                xyr = cos (p) * r >> 16;
            }
            
            SetActorAngle (C_TID + p_num, a);
            SetActorPitch (C_TID + p_num, p);
            
            if (r < MAX_R) 
            r += ADJUST_R;
        }
        
        delay (1);
    }
}